﻿dofile(ModPath .. "menu/menu.lua")

--Shortcuts
local clone_active = CloneArmy.settings.activated == true
local clone_shield = CloneArmy.settings.special_type == 1
local clone_taser = CloneArmy.settings.special_type == 2
local clone_cloaker = CloneArmy.settings.special_type == 3
local clone_bulldozer = CloneArmy.settings.special_type == 4
local clone_medic = CloneArmy.settings.special_type == 5
local clone_sniper = CloneArmy.settings.special_type == 6

Hooks:PostHook(GroupAITweakData, "_init_unit_categories", "clones_init_unit_categories", function(self, difficulty_index)
--Increases spawn limits
	if clone_active then
		self.special_unit_spawn_limits = {
			shield = 100,
			medic = 100,
			taser = 100,
			tank = 100,
			spooc = 100
		}
	end

--Sniper groups
	if clone_active and clone_sniper then
	--Russia and Federales only have one sniper each
		self.unit_categories.CS_swat_MP5.unit_types.russia = {Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_sniper_svd_snp/ene_akan_cs_swat_sniper_svd_snp")}
		self.unit_categories.CS_swat_R870.unit_types.russia = {Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_sniper_svd_snp/ene_akan_cs_swat_sniper_svd_snp")}
		self.unit_categories.FBI_swat_M4.unit_types.russia = {Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_sniper_svd_snp/ene_akan_cs_swat_sniper_svd_snp")}
		self.unit_categories.FBI_swat_R870.unit_types.russia = {Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_swat_sniper_svd_snp/ene_akan_cs_swat_sniper_svd_snp")}
		self.unit_categories.CS_swat_MP5.unit_types.federales = {Idstring("units/pd2_dlc_bex/characters/ene_swat_policia_sniper/ene_swat_policia_sniper")}
		self.unit_categories.CS_swat_R870.unit_types.federales = {Idstring("units/pd2_dlc_bex/characters/ene_swat_policia_sniper/ene_swat_policia_sniper")}
		self.unit_categories.FBI_swat_M4.unit_types.federales = {Idstring("units/pd2_dlc_bex/characters/ene_swat_policia_sniper/ene_swat_policia_sniper")}
		self.unit_categories.FBI_swat_R870.unit_types.federales = {Idstring("units/pd2_dlc_bex/characters/ene_swat_policia_sniper/ene_swat_policia_sniper")}
	--Murkywater uses FBI snipers on White House to prevent crashes
		if Global and Global.level_data and Global.level_data.level_id == "vit" then
			self.unit_categories.CS_swat_MP5.unit_types.murkywater = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.CS_swat_R870.unit_types.murkywater = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_M4.unit_types.murkywater = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_R870.unit_types.murkywater = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
		else
			self.unit_categories.CS_swat_MP5.unit_types.murkywater = {Idstring("units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper")}
			self.unit_categories.CS_swat_R870.unit_types.murkywater = {Idstring("units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper")}
			self.unit_categories.FBI_swat_M4.unit_types.murkywater = {Idstring("units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper")}
			self.unit_categories.FBI_swat_R870.unit_types.murkywater = {Idstring("units/pd2_dlc_bph/characters/ene_murkywater_sniper/ene_murkywater_sniper")}
		end

		if difficulty_index <= 3 then
			self.unit_categories.CS_swat_MP5.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.CS_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.CS_swat_MP5.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.CS_swat_R870.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_1/ene_sniper_1")}
		end
		if difficulty_index > 3 and difficulty_index < 6 then
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
		end
		if StreamHeist and difficulty_index > 5 and difficulty_index < 8 then
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_3/ene_sniper_3")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_3/ene_sniper_3")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_3/ene_sniper_3")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/payday2/characters/ene_sniper_3/ene_sniper_3")}
		elseif difficulty_index > 5 and difficulty_index < 8 then
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
		end
		if StreamHeist and difficulty_index == 8 then
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_sniper/ene_zeal_sniper")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_sniper/ene_zeal_sniper")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_sniper/ene_zeal_sniper")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_sniper/ene_zeal_sniper")}
		elseif difficulty_index == 8 then
			self.unit_categories.FBI_swat_M4.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_R870.unit_types.america = {Idstring("units/payday2/characters/ene_sniper_2/ene_sniper_2")}
			self.unit_categories.FBI_swat_M4.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
			self.unit_categories.FBI_swat_R870.unit_types.zombie = {Idstring("units/pd2_dlc_hvh/characters/ene_sniper_hvh_2/ene_sniper_hvh_2")}
		end
	end
end)

Hooks:PostHook(GroupAITweakData, "_init_enemy_spawn_groups", "clones_init_enemy_spawn_groups", function(self, difficulty_index)
	if clone_active then
	--Shields
		if StreamHeist then
			self.enemy_spawn_groups.tac_shield_wall_ranged = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall_ranged
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall_charge = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall_charge
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall = {
				amount = {
					6,
					6
				},
				spawn = {
					{
						amount_min = 6,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall
					}
				}
			}
		elseif difficulty_index <= 3 then
			self.enemy_spawn_groups.tac_shield_wall_ranged = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "CS_shield",
						tactics = self._tactics.shield_wall_ranged
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall_charge = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "CS_shield",
						tactics = self._tactics.shield_wall_charge
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall = {
				amount = {
					6,
					6
				},
				spawn = {
					{
						amount_min = 6,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "CS_shield",
						tactics = self._tactics.shield_wall
					}
				}
			}
		else
			self.enemy_spawn_groups.tac_shield_wall_ranged = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall_ranged
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall_charge = {
				amount = {
					3,
					6
				},
				spawn = {
					{
						amount_min = 3,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall_charge
					}
				}
			}
			self.enemy_spawn_groups.tac_shield_wall = {
				amount = {
					6,
					6
				},
				spawn = {
					{
						amount_min = 6,
						freq = 1,
						amount_max = 6,
						rank = 3,
						unit = "FBI_shield",
						tactics = self._tactics.shield_wall
					}
				}
			}
		end
	--Tasers
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				2,
				5
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 5,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_flanking
				}
			}
		}
		self.enemy_spawn_groups.tac_tazer_charge = {
			amount = {
				2,
				5
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 5,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	--Cloakers
		self.enemy_spawn_groups.single_spooc = {
			amount = {
				2,
				5
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 5,
					rank = 1,
					unit = "spooc",
					tactics = self._tactics.spooc
				}
			}
		}
		self.enemy_spawn_groups.FBI_spoocs = self.enemy_spawn_groups.single_spooc
	--Bulldozers
		self.enemy_spawn_groups.tac_bull_rush = {
			amount = {
				2,
				4
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 4,
					rank = 3,
					unit = "FBI_tank",
					tactics = self._tactics.tank_rush
				}
			}
		}
	--Medics
		if clone_medic then
			self.enemy_spawn_groups.tac_swat_shotgun_rush = {
				amount = {
					2,
					5
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 5,
						rank = 2,
						unit = "medic_R870",
						tactics = self._tactics.swat_shotgun_rush
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_shotgun_flank = {
				amount = {
					2,
					5
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 5,
						rank = 2,
						unit = "medic_R870",
						tactics = self._tactics.swat_shotgun_flank
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_rifle = {
				amount = {
					2,
					5
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 5,
						rank = 2,
						unit = "medic_M4",
						tactics = self._tactics.swat_rifle
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_rifle_flank = {
				amount = {
					2,
					5
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 5,
						rank = 2,
						unit = "medic_M4",
						tactics = self._tactics.swat_rifle_flank
					}
				}
			}
	--Snipers
		elseif clone_sniper then
			self.enemy_spawn_groups.tac_swat_shotgun_rush = {
				amount = {
					2,
					4
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 4,
						rank = 2,
						unit = "FBI_swat_R870",
						tactics = self._tactics.swat_shotgun_rush
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_shotgun_flank = {
				amount = {
					2,
					4
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 4,
						rank = 2,
						unit = "FBI_swat_R870",
						tactics = self._tactics.swat_shotgun_flank
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_rifle = {
				amount = {
					2,
					4
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 4,
						rank = 2,
						unit = "FBI_swat_M4",
						tactics = self._tactics.swat_rifle
					}
				}
			}
			self.enemy_spawn_groups.tac_swat_rifle_flank = {
				amount = {
					2,
					4
				},
				spawn = {
					{
						amount_min = 2,
						freq = 1,
						amount_max = 4,
						rank = 2,
						unit = "FBI_swat_M4",
						tactics = self._tactics.swat_rifle_flank
					}
				}
			}
		end
	end
end)

Hooks:PostHook(GroupAITweakData, "_init_task_data", "clones_init_task_data", function(self)
	if clone_active then
		for _, tac in pairs(self.besiege.assault.groups) do
			tac[1] = 0
			tac[2] = 0
			tac[3] = 0
		end
		for _, rec in pairs(self.besiege.recon.groups) do
			rec[1] = 0
			rec[2] = 0
			rec[3] = 0
		end
		if clone_shield then
			self.besiege.assault.groups.tac_shield_wall_ranged = { 0.4, 0.4, 0.4 }
			self.besiege.assault.groups.tac_shield_wall_charge = { 0.4, 0.4, 0.4 }
			self.besiege.assault.groups.tac_shield_wall = { 0.2, 0.2, 0.2 }
			self.besiege.recon.groups.tac_shield_wall_ranged = { 0.4, 0.4, 0.4 }
			self.besiege.recon.groups.tac_shield_wall_charge = { 0.4, 0.4, 0.4 }
			self.besiege.recon.groups.tac_shield_wall = { 0.2, 0.2, 0.2 }
		end
		if clone_taser then
			self.besiege.assault.groups.tac_tazer_flanking = { 0.5, 0.5, 0.5 }
			self.besiege.assault.groups.tac_tazer_charge = { 0.5, 0.5, 0.5 }
			self.besiege.recon.groups.tac_tazer_flanking = { 0.5, 0.5, 0.5 }
			self.besiege.recon.groups.tac_tazer_charge = { 0.5, 0.5, 0.5 }
		end
		if clone_cloaker then
			self.besiege.assault.groups.FBI_spoocs = { 1, 1, 1 }
			self.besiege.recon.groups.FBI_spoocs = { 1, 1, 1 }
		end
		if clone_bulldozer then
			self.besiege.assault.groups.tac_bull_rush = { 1, 1, 1 }
			self.besiege.recon.groups.tac_bull_rush = { 1, 1, 1 }
		end
		if clone_medic or clone_sniper then
			self.besiege.assault.groups.tac_swat_shotgun_rush = { 0.125, 0.125, 0.125 }
			self.besiege.assault.groups.tac_swat_shotgun_flank = { 0.125, 0.125, 0.125 }
			self.besiege.assault.groups.tac_swat_rifle = { 0.375, 0.375, 0.375 }
			self.besiege.assault.groups.tac_swat_rifle_flank = { 0.375, 0.375, 0.375 }
			self.besiege.recon.groups.tac_swat_shotgun_rush = { 0.125, 0.125, 0.125 }
			self.besiege.recon.groups.tac_swat_shotgun_flank = { 0.125, 0.125, 0.125 }
			self.besiege.recon.groups.tac_swat_rifle = { 0.375, 0.375, 0.375 }
			self.besiege.recon.groups.tac_swat_rifle_flank = { 0.375, 0.375, 0.375 }
		end
	end
end)